<template>
  <CCardBody>
    <template>
      <CSelect
        addInputClasses="customChevron"
        label="Склад автозаказа"
        :options="warehouses"
        :value.sync="ozonStorage.warehouseId"
        :invalidFeedback="invalidWarehouseIdMessage"
        :isValid="isInvalidWarehouseId"
      />
      <CSelect
        addInputClasses="customChevron"
        label="Склад остатков Ozon"
        :options="ozonWarehouses"
        :value.sync="ozonStorage.ozonWarehouseId"
        :invalidFeedback="invalidOzonWarehouseIdMessage"
        :isValid="isInvalidOzonWarehouseId"
      />
      <div class="controlButton">
        <CButton
          color="danger"
          class="cancel mr-2"
          @click="onClose(false)"
        >
          Отмена
        </CButton>
        <CButton
          color="primary"
          class="save"
          @click="onClose(true)"
        >
          Сохранить
        </CButton>
      </div>
    </template>
  </CCardBody>
</template>

<script>
  import {mapGetters, mapActions} from 'vuex';
  import fieldWarnings from "../../../../../constants/fieldWarnings";

  export default {
    name: "EditingOzonStorage",
    props: {
      ozonStorageInfo: {
        // Информация о редактируемой строке таблицы
        type: Object,
        default() {
          return {};
        },
      },
    },
    data() {
      return {
        ozonStorage: {},
        ozonSrotageCopy: {},
        warnings: {},
        defaultWarnings: {},
      }
    },
    computed: {
      isInvalidWarehouseId() {
        return 'warehouseId' in this.warnings ? false : null;
      },
      invalidWarehouseIdMessage() {
        return this.isInvalidWarehouseId === false ? this.warnings.warehouseId : '';
      },
      isInvalidOzonWarehouseId() {
        return 'ozonWarehouseId' in this.warnings ? false : null;
      },
      invalidOzonWarehouseIdMessage() {
        return this.isInvalidOzonWarehouseId === false ? this.warnings.ozonWarehouseId : '';
      },
      ...mapGetters(['ozonWarehouses', 'warehouses']),
    },
    watch: {
      'ozonStorage.warehouseId'(warehouseId) {
        const {message} = this.defaultWarnings.warehouseId;
        this.checkFieldValidation('warehouseId', warehouseId, message);
      },
      'ozonStorage.ozonWarehouseId'(ozonWarehouseId) {
        const {message} = this.defaultWarnings.ozonWarehouseId;
        this.checkFieldValidation('ozonWarehouseId', ozonWarehouseId, message);
      },
      ozonWarehouses(ozonWarehouses) {
        // Установка значения поля "Склад остатков Ozon" в случае, если оно не задано
        if (!this.ozonStorage.ozonWarehouseId && ozonWarehouses.length) {
          this.ozonStorage.ozonWarehouseId = ozonWarehouses[0].value;
        }
      },
    },
    created() {
      this.setDefaultData();
      this.setDefaultWarnings();
      this.getOzonWarehousesLocal();
    },
    methods: {
      setDefaultData() {
        // Установка полученных из Props значений для последующего их редактирвоаня
        const {warehouse_id, ozon_warehouse_id} = this.ozonStorageInfo;
        let ozonWarehouseId = +ozon_warehouse_id;
        if (!ozon_warehouse_id && this.ozonWarehouses.length) {
          ozonWarehouseId = this.ozonWarehouses[0].value;
        }
        let warehouseId = +warehouse_id;
        if (!this.warehouses.length) {
          warehouseId = '';
        }
        this.ozonStorage = {
          warehouseId,
          ozonWarehouseId,
        };
      },
      onClose(closeType) {
        if (closeType) {
          if (this.checkValidation()) {
            this.$emit('onClose', {closeType, data: this.ozonStorage});
          }
        } else {
          this.$emit('onClose', {closeType});
        }
      },
      checkValidation() {
        // Проверка корректности данных в полях
        return Object.keys(this.warnings).length === 0;
      },
      checkFieldValidation(
        field, value, warningMessage, compareFunc,
      ) {
        // Проверка поля на валидность
        // field String - название поля
        // value String - значение поля
        // warningMessage String - Текст, показываемый если поле не прошло валидацию
        // compareFunc Function - Функция валидирования поля
        const compareResult = compareFunc ? compareFunc(value) : defaultCompare(value);
        if (compareResult) {
          if (field in this.warnings) {
            this.warnings[field] = compareResult;
          } else {
            this.$set(this.warnings, field, compareResult);
          }
        } else if (field in this.warnings) {
          this.$delete(this.warnings, field);
        }

        function defaultCompare(value) {
          return value === '' ? warningMessage : false;
        }
      },
      setDefaultWarnings() {
        // Установка ошибок по умолчанию
        this.defaultWarnings = {
          warehouseId: {message: fieldWarnings.emptyField},
          ozonWarehouseId: {message: fieldWarnings.emptyField},
        }
      },
      getOzonWarehousesLocal() {
        // Полечение данных для селектбокса
        if (!this.ozonWarehouses.length) {
          this.getOzonWarehouses()
            .catch(() => {
              this.ozonStorage.ozonWarehouseId = '';
            });
        }
      },
      ...mapActions(['getOzonWarehouses', 'getWarehousesCompliancesBoth']),
    },
  }
</script>
